<?php
/**
 * Created By       : Sergey Jdanuk aka Shadoof <jdanuk at gmail.com>
 * Created Date     : 04.04.13 19:23
 *
 * Description      : 
 *
 * History          :
 *
 * File name        : setup.php
 */
class Setup extends Screen {

    static $key_enter_open_folder=array
    (
        GUI_EVENT_KEY_ENTER=>array
        (
            GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
            GuiAction::params => array
            (
//                'command'=>'play',
            ),
        ),
    );

    static function getDialogForLoggedUser() {
        $defs = array(
            array
            (
                GuiControlDef::name=>"login",
                GuiControlDef::title=>'',
                GuiControlDef::kind=>GUI_CONTROL_LABEL,
                GuiControlDef::specific_def=>
                array
                (
                    GuiLabelDef::caption=>(string)"Ваш логин: " . Cookie::get('login'),
                ),
            ),
            array
            (
                GuiControlDef::name=>"login_BtnOK",
                GuiControlDef::title=>"",
                GuiControlDef::kind=>GUI_CONTROL_BUTTON,
                GuiControlDef::specific_def=>
                array
                (
                    GuiButtonDef::caption => "Сменить пользователя",
                    GuiButtonDef::width => 150,

                    GuiButtonDef::push_action=>array
                    (
                        GuiAction::handler_string_id=>PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                        GuiAction::caption=>null,
                        GuiAction::data=>NULL,
                        GuiAction::params=>array(
                            'command'=>'SHOW_LOGIN_DIALOG_BEGIN',
                        ),
                    ),
                ),
            ),
        );
        return ActionFactory::show_dialog('Информация', $defs, true);
    }

    static function getDialogForNotLoggedUser() {
        $defs = array(
            array
            (
                GuiControlDef::name=>"login",
                GuiControlDef::title=>"Логин",
                GuiControlDef::kind=>GUI_CONTROL_TEXT_FIELD,
                GuiControlDef::specific_def=>
                array
                (
                    GuiTextFieldDef::initial_value=>(string)Cookie::get('login'),
                    GuiTextFieldDef::numeric=>1,
                    GuiTextFieldDef::password=>0,
                    GuiTextFieldDef::has_osk=>0,
                    GuiTextFieldDef::always_active=>1,
                    GuiTextFieldDef::width=>400,
                ),
            ),
            array
            (
                GuiControlDef::name         => "password",
                GuiControlDef::title        => "Пароль",
                GuiControlDef::kind         => GUI_CONTROL_TEXT_FIELD,
                GuiControlDef::specific_def => array
                (
                    GuiTextFieldDef::initial_value  => "",
                    GuiTextFieldDef::numeric        => 1,
                    GuiTextFieldDef::password       => 1,
                    GuiTextFieldDef::has_osk        => 0,
                    GuiTextFieldDef::always_active  => 1,
                    GuiTextFieldDef::width          => 400,
                ),
            ),
            array
            (
                GuiControlDef::name=>"login_BtnOK",
                GuiControlDef::title=>"",
                GuiControlDef::kind=>GUI_CONTROL_BUTTON,
                GuiControlDef::specific_def=>
                array
                (
                    GuiButtonDef::caption => "OK",
                    GuiButtonDef::width => 150,

                    GuiButtonDef::push_action=>array
                    (
                        GuiAction::handler_string_id=>PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                        GuiAction::caption=>null,
                        GuiAction::data=>NULL,
                        GuiAction::params=>array(
                            'command'=>'loginDialog_Action_OK',
                        ),
                    ),
                ),
            ),
        );
        return ActionFactory::show_dialog('Авторизация', $defs, true);
    }

    function input(&$arg) {
        self::touchPlugin();
        hd_print(__FUNCTION__);

        $request = Media_Url::decode($arg->selected_media_url);
        echo print_r($request, true);

        // =====================================================================
        if (isset($arg->command))
        {
            switch ($arg->command)
            {
                case "SHOW_LOGIN_DIALOG_BEGIN":
                {
                    return Action::close_dialog_and_run(array(
                        GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                        GuiAction::params => array(
                            'selected_media_url' => Media_Url::encode("Setup->index", array('command'=>'SHOW_LOGIN_DIALOG')),
                        ))
                    );
                }
                case 'loginDialog_Action_OK':
                {
                    $login    = trim($arg->login);
                    $password = trim($arg->password);

                    // Если логин или пароль не введены
                    // показываем ошибку
                    if( empty($login) || empty($password) )
                        return ActionFactory::show_error(false, 'Ошибка', array('Вы должны ввести свой логин и пароль'));

                    try
                    {
                        // Логин и пароль записываем в куки
                        Cookie::set('login', $login, 0);
                        Cookie::set('password', $password, 0);

                        // Пытаемся авторизироваться
                        $result = Stb_Auth::login( $login, $password );
                    }
                    catch(ErrorException $e)
                    {
                        $errors = json_decode($e->getMessage());
                        return ActionFactory::show_error(false, 'Ошибка', $errors);
                    }

                    return Action::close_dialog_and_run(array(
                        GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                        GuiAction::params => array(
                            'selected_media_url' => Media_Url::encode("Setup->index", array('command'=>'UPDATE_VIEW_BEGIN')),
                        ))
                    );
                }
            }
        }
        // =====================================================================

        if (isset($request->params))
        {
            $command = $request->params->command;

            switch ($command)
            {
                case "CHECK_SESSION":
                {
                    $userLogin = Cookie::get('login');
                    $userPassword = Cookie::get('password');
                    $userToken = Cookie::get('token');

                    if (empty($userLogin) || empty($userPassword) || empty($userToken))
                        return self::getDialogForNotLoggedUser();

                    return self::getDialogForLoggedUser();
                }

                case 'SHOW_LOGIN_DIALOG':
                    return self::getDialogForNotLoggedUser();

                case "CLOSE_SESSION":
                {
                    Cookie::set('password','', 0);
                    Cookie::set('token','', 0);
                    return Action::show_title_dialog("Сессия успешно закрыта");
                }
                case 'UPDATE_VIEW_BEGIN':
                    return Action::show_title_dialog("Данные успешно изменены");
            }
        }
        echo '_____________________________________________ END!';
        return Action::open_folder($arg->selected_media_url);
    }

    static function touchPlugin(){
        $install_dir = DuneSystem::$properties["install_dir_path"];
        $touch_file = "$install_dir/index.php";
        echo "touch file >> " . $touch_file;
        system("touch $touch_file");
    }
}