<?php

/**
 * @author Sergey Jdanuk aka Shadoof <jdanuk at gmail.com>
 */
class Welcome extends Screen
{
    function input (&$arg)
    {
	    hd_print( __METHOD__ );
	    $request = Media_Url::decode($arg->selected_media_url);
	    echo print_r($arg, true);
	    echo print_r($request, true);

	    if (isset($arg->control_id)) {
		    hd_print('Control_Id set: ' . $arg->control_id);
			switch ($arg->control_id) {
				case 'loginDialog_Action_OK': {
				    $login    = trim($arg->login);
				    $password = trim($arg->password);

					// Если логин или пароль не введены
					// показываем ошибку
				    if( empty($login) || empty($password) )
					    return ActionFactory::show_error(false, 'Ошибка', array('Вы должны ввести свой логин'));

				    try {
					    // Логин и пароль записываем в куки
					    Cookie::set('login', $login, 0);
					    Cookie::set('password', $password, 0);

					    // Пытаемся авторизироваться
					    $result = Stb_Auth::login( $login, $password );
				    }
				    catch(ErrorException $e) {
					    $errors = json_decode($e->getMessage());
					    return ActionFactory::show_error(false, 'Ошибка', $errors);
				    }

					return $this->loadCahnnelsAfterLogin();
			    }
				case 'notificationDialog_Action_OK': {
					return $this->loadCahnnelsAfterLogin();
				}
		    }
	    }

        if ( isset($request->params->action) )
        {
			hd_print('Params -> Action set: ' . $request->params->action);
			switch($request->params->action)
            {
	            // Кейс отвечает за авторизацию
                case "login":
                {
	                // получаем логин и пароль с кукисов
	                $login = Cookie::get('login');
					$password = Cookie::get('password');

					// если логин или пароль пустые
	                // перекидываем на диалог авторизации
					if( empty($login) || empty($password) )
					{
						return array
						(
							GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
							GuiAction::params =>array(
								'selected_media_url' => Media_Url::encode("Welcome->play",array('action'=>'showLoginDialog'))
							)
						);
					}

                    $result = 0;
                    try {
	                    Stb_Auth::login( $login, $password);

						hd_print('notifications request!');
						$notifications = Model::factory('notification')->find_all();
						if (!empty($notifications)) {
							$defs = array();
							foreach ($notifications as $key => $n) {
								$defs[] = array(
									GuiControlDef::name=>"notification_$key",
									GuiControlDef::kind=>GUI_CONTROL_LABEL,
									GuiControlDef::specific_def=> array (
										GuiLabelDef::caption=>(string)$n,
//										GuiLabelDef::max_lines => 50,
									),
								);
								$defs[] = array(
									GuiControlDef::name=>"notification_splitter_$key",
									GuiControlDef::kind=>GUI_CONTROL_LABEL,
									GuiControlDef::specific_def=> array (
										GuiLabelDef::caption=>"-------------------",
									),
								);
							}
							$defs[] = array(
								GuiControlDef::name=>"login_BtnOK",
								GuiControlDef::title=>"",
								GuiControlDef::kind=>GUI_CONTROL_BUTTON,
								GuiControlDef::specific_def=> array (
									GuiButtonDef::caption => "OK",
									GuiButtonDef::width => 150,

									GuiButtonDef::push_action=>array
									(
										GuiAction::handler_string_id=>PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
										GuiAction::caption=>null,
										GuiAction::data=>NULL,
										GuiAction::params=>array(
											'control_id'=>'notificationDialog_Action_OK',
										),
									),
								),
							);
							return ActionFactory::show_dialog('Сообщения', $defs, true);
						}
						else {
							$channels = Model::factory('channel')->find_all(true);
							$channel = current($channels);
							echo print_r($channel, true);
							// Если залогинились, переходим на запуск канала.

							return array
							(
								GuiAction::handler_string_id => PLUGIN_TV_PLAY_ACTION_ID,
								GuiAction::params => array(
									'selected_media_url' => Media_Url::encode("Welcome->playTV",
										array(
											'id'=>'0_'.Model::factory('channel')->makeId($channel),
											'media_url'=>$channel['media_url'],
											'logo'=>$channel['logo'],
											'name'=>$channel['name'],
											'description'=>$channel['description'],
										)),
								)
							);
						}
                    }
                    catch(ErrorException $e)
                    {
	                    $errors = json_decode($e->getMessage());
	                    return ActionFactory::show_error(true, 'Ошибка', $errors);
                    }
                }

	            // Кейс показывает только диалог авторизации
	            case "showLoginDialog":{
		            $defs = array(
			            array
			            (
				            GuiControlDef::name=>"login",
				            GuiControlDef::title=>"Логин",
				            GuiControlDef::kind=>GUI_CONTROL_TEXT_FIELD,
				            GuiControlDef::specific_def=>
				            array
				            (
					            GuiTextFieldDef::initial_value=>(string)Cookie::get('login'),
					            GuiTextFieldDef::numeric=>1,
					            GuiTextFieldDef::password=>0,
					            GuiTextFieldDef::has_osk=>0,
					            GuiTextFieldDef::always_active=>1,
					            GuiTextFieldDef::width=>400,
				            ),
			            ),
			            array
			            (
				            GuiControlDef::name         => "password",
				            GuiControlDef::title        => "Пароль",
				            GuiControlDef::kind         => GUI_CONTROL_TEXT_FIELD,
				            GuiControlDef::specific_def => array
				            (
					            GuiTextFieldDef::initial_value  => "",
					            GuiTextFieldDef::numeric        => 1,
					            GuiTextFieldDef::password       => 1,
					            GuiTextFieldDef::has_osk        => 0,
					            GuiTextFieldDef::always_active  => 1,
					            GuiTextFieldDef::width          => 400,
				            ),
			            ),
			            array
			            (
				            GuiControlDef::name=>"login_BtnOK",
				            GuiControlDef::title=>"",
				            GuiControlDef::kind=>GUI_CONTROL_BUTTON,
				            GuiControlDef::specific_def=>
				            array
				            (
					            GuiButtonDef::caption => "OK",
					            GuiButtonDef::width => 150,

					            GuiButtonDef::push_action=>array
					            (
						            GuiAction::handler_string_id=>PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
						            GuiAction::caption=>null,
						            GuiAction::data=>NULL,
						            GuiAction::params=>array(
							            'control_id'=>'loginDialog_Action_OK',
						            ),
					            ),
				            ),
			            ),
		            );
		            return ActionFactory::show_dialog('Авторизация', $defs, true);
		            break;
	            }
            }
        }

        return Action::open_folder($arg->selected_media_url);
    }


	function loadCahnnelsAfterLogin () {
		$channels = Model::factory('channel')->find_all(true);
		$channel = $channels[0];

		// Если авторизация прошли успешно
		// Перекидываем пользователя на плеер
		return array (
			GuiAction::handler_string_id => CLOSE_DIALOG_AND_RUN_ACTION_ID,
			GuiAction::data => array
			(
				CloseDialogAndRunActionData::post_action => array
				(
					GuiAction::handler_string_id => PLUGIN_TV_PLAY_ACTION_ID,
					GuiAction::params => array(
						'selected_media_url' => Media_Url::encode("Welcome->playTV",
								array(
									'id'=>'0_'.Model::factory('channel')->makeId($channel),
									'media_url'=>$channel['media_url'],
									'logo'=>$channel['logo'],
									'name'=>$channel['name'],
									'description'=>$channel['description'],
								)),
					)
				),
			),
		);
	}
	/**
     * Возвращает масив с данными для Плеера.
     * В масиве находятся:
     *      - список категорий
     *      - список каналов, соответствующие одной категории
     *      - параметры настроек
     * @param $id
     * @param $media_url
     * @param $logo
     * @param $name
     * @param $description
     * @return array
     */
    function playTV($id , $media_url , $logo , $name , $description)
	{

		hd_print( __METHOD__ . ' ' . $id , $media_url . $logo . $name . $description );
        echo print_r(func_get_args(), true);

		$genres = Model::factory('genre')->find_all();

        $initial_group_id = FALSE;
        $groups = array();
//		$groups = array(
//			Plugin::tvGroup('0', 'Все каналы', 'gui_skin://small_icons/iptv.aai')
//		);

		foreach($genres as $cat)
        {
            if( $initial_group_id === FALSE )
                $initial_group_id = (string)$cat['id'];
			$groups [] = Plugin::tvGroup((string)$cat['id'], $cat['name'], 'gui_skin://small_icons/iptv.aai');
        }

		$configChannels = self::loadChannels();
        $channels = array();

        $initial_channel_id = FALSE;

        $modelChannel = Model::factory('channel');

        $unixtime = time() - get_time_zone();

		foreach($configChannels as $k=>$v)
		{
			$arr = Arr::extract($v,array('id','epg_channel_id','logo','name', 'categories', 'record_period', 'genre_id','adult','channel_id'));

			$record_period = (int)$arr['record_period'];
            $channel_id = $arr['channel_id'].'_'.$modelChannel->makeId($arr);
			$media_url = Media_Url::encode('Welcome', array('channel_id'=>$channel_id));

			$arr['logo'] = (string) (empty( $arr['logo'] ) ?
				'gui_skin://small_icons/favorites.aai' : $arr['logo']);

            $isAdultChannel = (int)$arr['adult'];

            if( $initial_channel_id == FALSE)
				$initial_channel_id=Media_Url::encode('Welcome', array('channel_id'=>Cookie::get('play_channel_id',$channel_id)));

//            $group_ids = array('0');
//            if( (int)$arr['genre_id'] > 0 )
//                $group_ids = Arr::merge( $group_ids, array($arr['genre_id']));

			$channels [] = array(
				PluginTvChannel::id                => (string)$media_url,
				PluginTvChannel::caption           => $arr['name'],
				PluginTvChannel::group_ids         => array($arr['genre_id']),
//				PluginTvChannel::group_ids         => array('0'),
				PluginTvChannel::icon_url          => $arr['logo'],
				PluginTvChannel::number            => -1,
				PluginTvChannel::have_archive      => $record_period != 0,
				PluginTvChannel::is_protected      => $isAdultChannel,
				PluginTvChannel::past_epg_days     => 7,
				PluginTvChannel::future_epg_days   => 7,
				PluginTvChannel::archive_past_sec  => (60*60*24*$record_period),
				PluginTvChannel::archive_delay_sec => 0,
				PluginTvChannel::buffering_ms      => 5000,
				PluginTvChannel::timeshift_hours   => 0,
				PluginTvChannel::playback_url_is_stream_url => TRUE
			);
		}
		if (class_exists('controller')){
		$fav_channel_ids = controller::get_fav_channel_ids($plugin_cookies);
			echo '========FAVORITE CHANNELS=======';
			print_r ($fav_channel_ids);
			echo '========FINISH FAV CHAN=========';
		}
		else $fav_channel_ids=array();
		$tv = array
		(
			PluginTvInfo::show_group_channels_only  => FALSE,
			PluginTvInfo::groups                    => $groups,
			PluginTvInfo::channels                  => $channels,
			PluginTvInfo::favorites_supported       => FALSE,
			PluginTvInfo::favorites_icon_url        => 'gui_skin://small_icons/favorites.aai',
			PluginTvInfo::initial_channel_id        => $initial_channel_id,
			PluginTvInfo::initial_group_id          => $initial_group_id,
			PluginTvInfo::initial_is_favorite       => FALSE,
			PluginTvInfo::favorite_channel_ids      => $fav_channel_ids,
			PluginTvInfo::archive                   => NULL,
		);
//        echo print_r($tv, true);
		return $tv;
	}

    static function loadEpg($channel, $ts){
        echo __METHOD__;
        try {
            echo print_r($channel, true);
            $epg_channel_id = intval($channel['epg_channel_id']);
            if( $epg_channel_id < 1 )
                return array();
            if( $ts == -1 )
                $ts = time();
            $epg_date = date("Y-m-d", $ts);
            $url = Stb::getEpgUrl($epg_channel_id, $epg_date);

            printf( "Загружаем программы для канала [%s], дата: %s ... ",
                $channel['name'],
                $epg_date);

//            $epg_json = Stb::get_http_request( $url );
            $epg_json = HD::http_get_document( $url );
            $epg = json_decode($epg_json, TRUE);
            echo "Загружено " . count($epg) . " программ";
            return $epg;
        }
        catch (Exception $e) {
            hd_print("Can't fetch EPG ID:$epg_channel_id DATE:$epg_date");
            return array();
        }
    }


    /**
     * @description Загружает все ТВ каналы с сервера и возвращает их.
     * В случае возникновения исключающей ситуации возвращает пустой масив
     *
     * @return array
     */
    static function loadChannels(){
        hd_print(__FUNCTION__);
        try
        {
            return Model::factory('channel')->find_all(true);
        }
        catch (Exception $e) {
            hd_print("Can't fetch channels.");
            return array();
        }
    }

    static function getAdultEpgProgramByTime($channel, $epg, $ts, $protect_code){
        if (empty($protect_code))
            return 'protected';

        $result = HD::http_post_document( Stb::getCheckAdultPasswordUrl(), array('password'=>$protect_code) );
        $result = json_decode($result, true);

        if ($result['code'] != REQUEST_CODE_OK)
            return 'protected';

        return self::getEpgProgramByTime($channel, $epg, $ts);
    }

    static function getEpgProgramByTime($channel, $epg, $ts){
        hd_print(__METHOD__ . ' $channel='. $channel.'; epg='. $epg .'; $ts='. $ts);
//        echo print_r($channel, true);
       // echo print_r($epg, true);

        $program = array('media_url'=>'');
        $prevProgram = $program;
        $begin = NULL;
        $end = NULL;
        $isCurrent = false;
        $now = time();
        echo " >>> " . date("Y-m-d H:i:s", $ts) . ', now = ' . date("Y-m-d H:i:s", time() );


        foreach($epg as $k=>$v)
        {
/*            $begin = $prevProgram['begin'] = $v['start_unix'];
            $end = $prevProgram['end'] = $v['stop_unix'];

            if( $begin == $ts )
            {
                $program = $v;
                break;
            }
            if( $begin > $ts )
            {
                $begin = $ts;
                $program = $prevProgram;
                break;
            }
	    if ($begin < $ts){
				$begin = $ts;
		}
            $prevProgram = $v;
*/
			$begin = $v['start_unix'];
			$end = $v['stop_unix'];

			if ( $begin <= $ts and $ts < $end ) {
				$begin=$ts;
				break;
			}
        }

//        $begin -= get_time_zone();
//        $end -= get_time_zone();

//	if ($begin < $now && $end > $now)
//		$end = null;

        $program = array(
            'media_url'=>Stb::getTvRecordedLink(
                    $channel['channel_id'],
                    $begin,
                    $end
            )
        );

//        $currentTime = time();
//        if ($begin <= $currentTime && $end > $currentTime) {
//            echo "Выдаем MEDIA_URL с канала " . $channel['media_url'];
//            $program['media_url'] = $channel['media_url'];
//        }


        //echo print_r($program, true);
        echo self::makeUrl($program['media_url']);
        return $program;
    }

    /**
     * Проверяет пароль для запуска канала для взрослых.
     * Если пароль правильный, отдает url для проигрывания
     *
     * @param $channel
     * @param $protect_code
     * @return string
     */
    static function getChannelAdultUrl($channel, $protect_code) {
        if (empty($protect_code))
            return 'protected';

        $result = HD::http_post_document( Stb::getCheckAdultPasswordUrl(), array('password'=>$protect_code) );
        $result = json_decode($result, true);

        if ($result['code'] != REQUEST_CODE_OK)
            return 'protected';

        return self::makeUrl($channel['media_url']);
    }

    /**
     * Проверяет является канал каналом для взросьлых
     *
     * @param $channel
     * @return bool
     */
    static function isChannelAdult($channel) {
        return (isset($channel['adult']) && (int)$channel['adult'] == 1);
    }

    /**
     * @description Возвращает media_url для указанного канала.
     *
     * @param $id ID канала в формате 2_2e324677bcf598e248d0454bf67d0d3d_51 <index_in_channels_array>_<hash>_<epg_channel_id>
     * @param $archive_ts - время записанной программы которую выбрали проиграть. Если $archive_ts РАВЕН -1 это означает
     * что должен запуститься канал и началось проигрывание LIVE stream. Если $archive_ts НЕ РАВЕН -1 - означает
     * что должны проигать записанную программу.
     * @param $protect_code
     * @return string media_url
     */
    static function get_tv_playback_url($id, $archive_ts, $protect_code){
		$tmp = explode('_',$id);
		$channel_id = $tmp[0];
		hd_print(__METHOD__ . ' channel_id: ' . $id . ', archive_ts: ' . $archive_ts . ', protect_code: ' . $protect_code . 'File: '. __FILE__);
		Cookie::set('play_channel_id', $id, 0);
        $channels = self::loadChannels();

        // Нужный канал отсутствует в списке?
        if( !isset($channels[$channel_id]) )
            return "";

        $channel = $channels[$channel_id];
        if( $archive_ts == -1 )
        {
            if (self::isChannelAdult($channel))
                return self::getChannelAdultUrl($channel, $protect_code);

            return self::makeUrl($channel['media_url']);
        }

        $epg = self::loadEpg($channel, $archive_ts);
        $program = self::getEpgProgramByTime($channel, $epg, $archive_ts);

        if (self::isChannelAdult($channel))
            $program = self::getAdultEpgProgramByTime($channel, $epg, $archive_ts,$protect_code);

        return self::makeUrl($program['media_url']);
	}

    static function makeUrl($media_url) {
		hd_print(__METHOD__.' Media_url: '.$media_url);
        $str = str_replace('http://','http://ts://',$media_url .'?token=' . Stb::token() . '&login='. Stb::login() . '|||dune_params|||protocol:autodetect,buffering_ms:5000');
		return $str;
    }

    /**
     * @description Получает с сервера список программ для указанной даты и возвращает их в виде массива.
     *
     * @param $id ID канала в формате 2_2e324677bcf598e248d0454bf67d0d3d_51 <index_in_channels_array>_<hash>_<epg_channel_id>
     * @param $day_start_ts Дата для которой получить список программ
     * @return array масив программ для указанной даты в $day_start_ts
     */
    static function get_day_epg($id, $day_start_ts)
	{
		hd_print( __METHOD__  . ' ' . $id);

        // Получаем масив программ для указанной даты и в цикле формируем масив чтобы отдать его плееру.
		$epg = array();

		foreach (self::get_day_epg_iterator($id, $day_start_ts) as $e)
		{
            $epg[] =
                array
                (
                    PluginTvEpgProgram::start_tm_sec    => $e->get_start_time(),
                    PluginTvEpgProgram::end_tm_sec      => $e->get_finish_time(),
                    PluginTvEpgProgram::name            => html_entity_decode($e->get_title()),
                    PluginTvEpgProgram::description     => html_entity_decode($e->get_description())
                );
        }

        return $epg;
    }

    static function get_day_epg_iterator($id, $day_start_ts)
    {
        hd_print( __METHOD__ );
        echo print_r(func_get_args(), true);
        $id = explode('_', $id);
        $channel_id = $id[0];

        // Получаем список каналов
        $channels = self::loadChannels();

        // Нужный канал отсутствует в списке?
        if( !$channels[$channel_id] )
            return array();

        $channel = $channels[$channel_id];

		echo "Epg day start: " . $day_start_ts . ', ' . date("d-m-Y H:i:s", $day_start_ts);

        $epg = self::loadEpg($channel, $day_start_ts );

        // С полученного EPG на указанный день формируем масив программ.

		$epg_result = array();
		foreach ($epg as $time => $value)
		{
			$start_time = (int)$value['start_unix'];
			$end_time = (int)$value['stop_unix'];

			$epg_result[] =
				new DefaultEpgItem(
					strval($value["title"]),
//					'',
                    strval($value["description"]),
					intval($start_time),
					intval($end_time)
				);
		}
        return $epg_result;
//		return new EpgIterator($epg_result, $day_start_ts, $day_start_ts + 100400  );
	}

	static function get_tv_stream_url($media_url){
		hd_print( __METHOD__ );
		return $media_url;
	}

    static function getDialog() {
            $defs = array(
                array
                (
                    GuiControlDef::name=>"login",
                    GuiControlDef::title=>"Логин",
                    GuiControlDef::kind=>GUI_CONTROL_TEXT_FIELD,
                    GuiControlDef::specific_def=>
                    array
                    (
                        GuiTextFieldDef::initial_value=>(string)Cookie::get('login'),
                        GuiTextFieldDef::numeric=>1,
                        GuiTextFieldDef::password=>0,
                        GuiTextFieldDef::has_osk=>0,
                        GuiTextFieldDef::always_active=>1,
                        GuiTextFieldDef::width=>400,
                    ),
                ),
                array
                (
                    GuiControlDef::name         => "password",
                    GuiControlDef::title        => "Пароль",
                    GuiControlDef::kind         => GUI_CONTROL_TEXT_FIELD,
                    GuiControlDef::specific_def => array
                    (
                        GuiTextFieldDef::initial_value  => "",
                        GuiTextFieldDef::numeric        => 1,
                        GuiTextFieldDef::password       => 1,
                        GuiTextFieldDef::has_osk        => 0,
                        GuiTextFieldDef::always_active  => 1,
                        GuiTextFieldDef::width          => 400,
                    ),
                ),
                array
                (
                    GuiControlDef::name=>"login_BtnOK",
                    GuiControlDef::title=>"",
                    GuiControlDef::kind=>GUI_CONTROL_BUTTON,
                    GuiControlDef::specific_def=>
                    array
                    (
                        GuiButtonDef::caption => "OK",
                        GuiButtonDef::width => 150,

                        GuiButtonDef::push_action=>array
                        (
                            GuiAction::handler_string_id=>PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                            GuiAction::caption=>null,
                            GuiAction::data=>NULL,
                            GuiAction::params=>array(
                                'command'=>'loginDialog_Action_OK',
                            ),
                        ),
                    ),
                ),
            );
            return ActionFactory::show_dialog('Авторизация', $defs, true);
        }
}
